<template>
  <div class="_login elm-center">
    <div class="_login-container">
      <b-form @submit.prevent="submitLogin">
        <div class="login-head">
          <b-row>
            <b-col class="text1 font-weight-bold">
              <span>
                SIGN IN
              </span>
            </b-col>
          </b-row>
        </div>
        <div class="login-form">
          <b-row>
            <b-col>
              <b-form-group>
                <b-form-input
                  v-model="form.username"
                  id="username-inp"
                  required
                  placeholder="Username"
                ></b-form-input>
              </b-form-group>
              <b-form-group>
                <b-form-input
                  v-model="form.password"
                  id="password-inp"
                  required
                  placeholder="Password"
                  type="password"
                ></b-form-input>
              </b-form-group>
            </b-col>
          </b-row>
        </div>
        <div class="login-submit">
          <b-row>
            <b-col>
              <b-button class="w-100" type="submit">Sign In</b-button>
            </b-col>
          </b-row>
        </div>
      </b-form>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { SignInType } from "../../store/auth/types";
import { Action } from "vuex-class";

const namespace: string = "auth";

@Component({
  name: "Login"
})
export default class _Login extends Vue {
  form: SignInType = {
    username: "",
    password: ""
  };

  @Action("signin", { namespace }) signin!: any;

  submitLogin() {
    const payload: SignInType = {
      username: this.form.username,
      password: this.form.password
    };

    this.signin(payload).then(
      (resp: string) => {
        this.$swal({
          type: "success",
          title: "Sign in successfully",
          text: `You are logged in with "${resp}" user.`
        });
      },
      (err: string) => {
        this.$swal({
          type: "error",
          title: "Sign in failure",
          text: err
        });
      }
    );
  }
}
</script>